<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 06/17/2004 *
 * ================                             Last change: 01/13/2006 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-holiday.php                                  *
 * -------------------------------------------------------------------- *
 * Short description : Holiday requests from members                    *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Ferienantraege von Mitgliedern                   *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Version number
EXT_SET_VERSION("0.2.1");

// Version history array (add more with , "0.1" and so on)
EXT_SET_VER_HISTORY(array("0.0", "0.0.1", "0.0.2", "0.0.3", "0.0.4", "0.0.5", "0.0.6", "0.0.7", "0.0.8", "0.0.9", "0.1.0", "0.1.1", "0.1.2", "0.1.3", "0.1.4", "0.1.5", "0.1.6", "0.1.7", "0.1.8", "0.1.9", "0.2.0", "0.2.1"));

switch ($EXT_LOAD_MODE)
{
case "register": // Do stuff when installation is running (modules.php?module=admin&action=login is called)
	// Create database
	ADD_SQL("DROP TABLE IF EXISTS `{!_MYSQL_PREFIX!}_user_holidays`");
	ADD_SQL("CREATE TABLE `{!_MYSQL_PREFIX!}_user_holidays` (
id BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
userid BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
holiday_start VARCHAR(10) NOT NULL DEFAULT 0,
holiday_end VARCHAR(10) NOT NULL DEFAULT 0,
comments LONGBLOB NOT NULL,
KEY (userid),
PRIMARY KEY(id)
) TYPE={!_TABLE_TYPE!}");

	// Add default values to config
	ADD_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_config` ADD holiday_max BIGINT(20) UNSIGNED NOT NULL DEFAULT '30'");

	// Add member menu
	ADD_SQL("INSERT INTO `{!_MYSQL_PREFIX!}_member_menu` (`action`,`what`,`title`,`sort`,`visible`,`locked`) VALUES ('main','holiday','Urlaubsschaltung','4','Y','Y')");

	// Add admin menus
	ADD_SQL("INSERT INTO `{!_MYSQL_PREFIX!}_admin_menu` (`action`, `what`, `title`, `sort`, `descr`) VALUES ('holiday', NULL, 'Urlaubsmanagement','4','Hier k&ouml;nnen Sie Urlaubsschaltungen Ihrer Mitglieder auflisten oder auch wieder aufheben.')");
	ADD_SQL("INSERT INTO `{!_MYSQL_PREFIX!}_admin_menu` (`action`, `what`, `title`, `sort`, `descr`) VALUES ('holiday','list_holiday','Auflisten','1','Alle Urlaubsschaltungen auflisten.')");
	ADD_SQL("INSERT INTO `{!_MYSQL_PREFIX!}_admin_menu` (`action`, `what`, `title`, `sort`, `descr`) VALUES ('holiday','del_holiday','Urlaub beenden','2','Urlaubsschaltungen aufheben. Geben Sie bitte mehr als nur &quot;Verstoss gegen unsere AGBs&quot; ein!')");
	ADD_SQL("INSERT INTO `{!_MYSQL_PREFIX!}_admin_menu` (`action`, `what`, `title`, `sort`, `descr`) VALUES ('holiday','config_holiday','Einstellungen','3','Maximale Tage f&uuml;r Urlaub usw. einstellen.')");

	// Remove 0 max mails per day
	ADD_SQL("DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_max_receive` WHERE value='0' LIMIT 1");
	break;

case "remove": // Do stuff when removing extension
	// SQL commands to run
	ADD_SQL("DROP TABLE IF EXISTS `{!_MYSQL_PREFIX!}_user_holidays`");
	ADD_SQL("DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_member_menu` WHERE `what`='holiday' LIMIT 1");
	ADD_SQL("DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_admin_menu` WHERE `action`='holiday' LIMIT 4");
	ADD_SQL("DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_max_receive` WHERE value='0' LIMIT 1");
	ADD_SQL("INSERT INTO `{!_MYSQL_PREFIX!}_max_receive` (value, comment) VALUES ('0','Urlaub')");
	break;

case "activate": // Do stuff when admin activates this extension
	// SQL commands to run
	ADD_SQL("UPDATE `{!_MYSQL_PREFIX!}_member_menu` SET `visible`='Y', `locked`='N' WHERE `what`='holiday' LIMIT 1");
	break;

case "deactivate": // Do stuff when admin deactivates this extension
	// SQL commands to run
	ADD_SQL("UPDATE `{!_MYSQL_PREFIX!}_member_menu` SET `visible`='N', `locked`='Y' WHERE `what`='holiday' LIMIT 1");
	break;

case "update": // Update an extension
	switch ($EXT_VER)
	{
	case "0.0.2": // SQL queries for v0.0.2
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Fehlende Abfrage im Mitlieder-Modul, on Erweiterung auch aktiviert ist.");
		break;

	case "0.0.3": // SQL queries for v0.0.3
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.");
		break;

	case "0.0.4": // SQL queries for v0.0.4
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Problem mit Speicherung der Einstellungen beseitigt.");
		break;

	case "0.0.5": // SQL queries for v0.0.5
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Men&uuml;punkte im Gast-/Mitgliedsbereich k&ouml;nnen nicht mehr aufgerufen werden, wenn die Erweiterung deaktiviert ist.");
		break;

	case "0.0.6": // SQL queries for v0.0.6
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Seit <a href=\"#\">Patch 340</a> &uuml;berfl&uuml;ssige HTML-Tags entfernt.");
		break;

	case "0.0.7": // SQL queries for v0.0.7
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("IP-Nummer und Browserbezeichnung wird in Admin-Mails eingesetzt.");
		break;

	case "0.0.8": // SQL queries for v0.0.8
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Link zum Mitgliedsprofil in Funktion <u>ADMIN_USER_PROFILE_LINK()</u> ausgelagert.");
		break;

	case "0.0.9": // SQL queries for v0.0.9
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("W&ouml;rter <strong>Mailtausch</strong>, <strong>Mailtausches</strong> und <strong>Mailtauscher</strong> sind austauschbar.");
		break;

	case "0.1.0": // SQL queries for v0.2.1
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Sicherheitsupdate: SQL-Anweisungen gesch&uuml;tzt.");
		break;

	case "0.1.1": // SQL queries for v0.1.1
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Abspeichern von Einstellungen repariert.");
		break;

	case "0.1.2": // SQL queries for v0.1.2
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Abspeichern der Urlaubsanfrage korregiert.");
		break;

	case "0.1.3": // SQL queries for v0.1.3
		ADD_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_user_data` ADD holiday_active ENUM('Y','N') NOT NULL DEFAULT 'N'");
		ADD_SQL("DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_max_receive` WHERE value='0' LIMIT 1");
		ADD_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_config` ADD holiday_lock BIGINT(20) UNSIGNED NOT NULL DEFAULT '".(getConfig('one_day')*2)."'");

		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Die Mitglieder-Accounts werden nicht mehr gesperrt, sondern nur auf <strong>Urlaub</strong> geschaltet. Lassen Sie sich nicht davon verwirren, dass sie &quot;freigegeben&quot; sind!");
		break;

	case "0.1.4": // SQL queries for v0.1.4
		ADD_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_config` ADD holiday_mode ENUM('DIRECT','RESET') NOT NULL DEFAULT 'RESET'");

		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Urlaubsschaltung wird erst Abends um 00:00 Uhr aktiv und nicht durch die Beantragung. Dies kann nun auch auf direkte Umstellung eingestellt werden.");
		break;

	case "0.1.5": // SQL queries for v0.1.5
		ADD_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_config` ADD holiday_mode ENUM('DIRECT','RESET') NOT NULL DEFAULT 'RESET'");

		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Sicherheitsupdate f&uuml;r die Include-Befehle.");
		break;

	case "0.1.6": // SQL queries for v0.1.6
		ADD_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_user_data` ADD holiday_activated BIGINT(20) UNSIGNED NOT NULL DEFAULT 0");

		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Fehlende Tabellenspalte hinzugef&uuml;gt.");
		break;

	case "0.1.7": // SQL queries for v0.1.7
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("if-Anweisungen auf Funktion <strong>empty()</strong> umgestellt.");
		break;

	case "0.1.8": // SQL queries for v0.1.8
		ADD_SQL("INSERT INTO `{!_MYSQL_PREFIX!}_admin_menu_las` (la_id, la_action, la_what) VALUES ('member', '', 'list_holiday')");
		ADD_SQL("INSERT INTO `{!_MYSQL_PREFIX!}_admin_menu_las` (la_id, la_action, la_what) VALUES ('member', '', 'del_holiday')");
		ADD_SQL("INSERT INTO `{!_MYSQL_PREFIX!}_admin_menu_las` (la_id, la_action, la_what) VALUES ('config', '', 'config_holiday')");

		// Depends on sql_patches (or you have to execute these both SQL statements by phpMyAdmin
		EXT_SET_UPDATE_DEPENDS("sql_patches");

		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Erweiterung in's neue Men&uuml;system integriert.");
		break;

	case "0.1.9": // SQL queries for v0.1.9
		ADD_SQL("UPDATE `{!_MYSQL_PREFIX!}_member_menu` SET `action`='account', `sort`='2', `title`='In Urlaub' WHERE `what`='holiday' LIMIT 1");

		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Mitgliedsmen&uuml; komplett umgebaut.");
		break;

	case "0.2.0": // SQL queries for v0.2.0
		ADD_SQL("UPDATE `{!_MYSQL_PREFIX!}_admin_menu` SET title = 'Urlaubsmanagement' WHERE action = 'holiday' AND (what='' OR `what` IS NULL) LIMIT 1");

		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Mitgliedsmen&uuml; komplett umgebaut.");
		break;

	case "0.2.1": // SQL queries for v0.2.1
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Fehlerhinweis bei deaktivierter Erweiterung verbessert.");
		break;
	}
	break;

case "modify": // When the extension got modified
	break;

case "test": // For testing purposes. For details see file inc/modules/admin/what-extensions.php, arround line 305.
	break;

default: // Do stuff when extension is loaded
	break;
}

//
?>
