<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 08/03/2004 *
 * ================                             Last change: 11/19/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : task_functions.php                               *
 * -------------------------------------------------------------------- *
 * Short description : Special task functions                           *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Spezielle task-Funktionen                        *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

//
// The advanced overview shows detailed informations to your exchange script:
//  - Unconfirmed / locked accounts
//  - Mails waiting to be approved
//  - Open tasks
//  - Your own tasks
//  - ...
//
// @TODO Move all extension-dependent queries into filters
function OUTPUT_ADVANCED_OVERVIEW (&$result_main) {
	// Init variables/arrays
	$EXTRAS = "";
	$OUT = "";
	$WHATs = array();
	$DESCRs = array();
	$TITLEs = array();

	// Chheck for new extensions and updates
	$JOBS_DONE = OUTPUT_STANDARD_OVERVIEW($result_main);

	// Init SQLs
	INIT_SQLS();

	if (!$JOBS_DONE) {
		// New extensions or updates found
		$value = GET_TOTAL_DATA(GET_CURRENT_ADMIN_ID(), "task_system", "id", "assigned_admin", true, " AND `status`='NEW' AND task_type='EXTENSION_UPDATE'");

		if ($value > 0) {
			define('__TASK_UPDATE_VALUE', "<a href=\"{!URL!}/modules.php?module=admin&amp;what=list_task&amp;type=updates\">".$value."</a>");
		} else {
			define('__TASK_UPDATE_VALUE', "0");
		}
	} else {
		define('__TASK_UPDATE_VALUE', "0");
	}

	//
	// First check for all account status seperately
	//
	// Confirmed accounts
	$value = GET_TOTAL_DATA("CONFIRMED", "user_data", "userid", "status", true);

	if ($value > 0) {
		define('__CONFIRMED_VALUE', "<a href=\"{!URL!}/modules.php?module=admin&amp;what=list_user&amp;status=confirmed\">".$value."</a>");
	} else {
		define('__CONFIRMED_VALUE', "0");
	}

	// Unconfirmed accounts
	$value = GET_TOTAL_DATA("UNCONFIRMED", "user_data", "userid", "status", true);

	if ($value > 0) {
		define('__UNCONFIRMED_VALUE', "<a href=\"{!URL!}/modules.php?module=admin&amp;what=chk_regs\">".$value."</a>");
	} else {
		define('__UNCONFIRMED_VALUE', "0");
	}

	// And locked accounts
	$value = GET_TOTAL_DATA("LOCKED", "user_data", "userid", "status", true);

	if ($value > 0) {
		define('__LOCKED_VALUE', "<a href=\"{!URL!}/modules.php?module=admin&amp;what=list_user&amp;status=locked\">".$value."</a>");
	} else {
		define('__LOCKED_VALUE', "0");
	}

	//
	// Unassigned tasks
	//
	$value = GET_TOTAL_DATA("0", "task_system", "id", "assigned_admin", true, " AND `status` != 'DELETED'");

	if ($value > 0) {
		define('__TASK_NEW_VALUE', "<a href=\"{!URL!}/modules.php?module=admin&amp;what=list_task&amp;type=unassigned\">".$value."</a>");
	} else {
		define('__TASK_NEW_VALUE', "0");
	}

	//
	// Closed tasks
	//
	$value = GET_TOTAL_DATA("CLOSED", "task_system", "id", "status", true);

	if ($value > 0) {
		define('__TASK_CLOSED_VALUE', "<a href=\"{!URL!}/modules.php?module=admin&amp;what=list_task&amp;type=closed\">".$value."</a>");
	} else {
		define('__TASK_CLOSED_VALUE', "0");
	}

	//
	// Deleted tasks
	//
	$value = GET_TOTAL_DATA("DELETED", "task_system", "id", "status", true);

	if ($value > 0) {
		define('__TASK_DELETED_VALUE', "<a href=\"{!URL!}/modules.php?module=admin&amp;what=list_task&amp;type=deleted\">".$value."</a>");
	} else {
		define('__TASK_DELETED_VALUE', "0");
	}

	//
	// Solved tasks
	//
	$value = GET_TOTAL_DATA("SOLVED", "task_system", "id", "status", true, sprintf(" AND assigned_admin=%s", GET_CURRENT_ADMIN_ID()));

	if ($value > 0) {
		define('__TASK_SOLVED_VALUE', "<a href=\"{!URL!}/modules.php?module=admin&amp;what=list_task&amp;type=solved\">".$value."</a>");
	} else {
		define('__TASK_SOLVED_VALUE', "0");
	}

	//
	// Your tasks
	//
	$value = GET_TOTAL_DATA(GET_CURRENT_ADMIN_ID(), "task_system", "id", "assigned_admin", true, " AND status = 'NEW' AND task_type != 'EXTENSION_UPDATE'");

	if ($value > 0) {
		define('__TASK_YOUR_VALUE', "<a href=\"{!URL!}/modules.php?module=admin&amp;what=list_task\">".$value."</a>");
	} else {
		define('__TASK_YOUR_VALUE', "0");
	}

	//
	// Mails waiting to be approved
	//
	$value = GET_TOTAL_DATA("ADMIN", "pool", "id", "data_type", true);

	if ($value > 0) {
		define('__MAIL_ADMIN_VALUE', "<a href=\"{!URL!}/modules.php?module=admin&amp;what=unlock_emails\">".$value."</a>");
	} else {
		define('__MAIL_ADMIN_VALUE', "0");
	}

	//
	// Unfinished mail orders
	//
	$value = GET_TOTAL_DATA("TEMP", "pool", "id", "data_type", true);

	if ($value > 0) {
		define('__MAIL_TEMP_VALUE', "<a href=\"{!URL!}/modules.php?module=admin&amp;what=email_details\">".$value."</a>");
	} else {
		define('__MAIL_TEMP_VALUE', "0");
	}

	//
	// Sent mail orders
	//
	$value = GET_TOTAL_DATA("SEND", "pool", "id", "data_type", true);

	if ($value > 0) {
		define('__MAIL_SEND_VALUE', "<a href=\"{!URL!}/modules.php?module=admin&amp;what=email_archiv\">".$value."</a>");
	} else {
		define('__MAIL_SEND_VALUE', "0");
	}

	//
	// Autopurged mails
	//
	if (EXT_IS_ACTIVE("autopurge")) {
		// Get auto-purged mails
		$value = GET_TOTAL_DATA("DELETED", "pool", "id", "data_type", true);

		if ($value > 0) {
			define('__MAIL_DELETED_VALUE', "<a href=\"{!URL!}/modules.php?module=admin&amp;what=email_details\">".$value."</a>");
		} else {
			define('__MAIL_DELETED_VALUE', "0");
		}

		//
		// Autopurged bonus mails
		//
		if (GET_EXT_VERSION("bonus") >= "0.1.8") {
			// Get auto-purged bonus mails
			$value = GET_TOTAL_DATA("DELETED", "bonus", "id", "data_type", true);

			if ($value > 0) {
				define('__MAIL_BONUS_AP_VALUE', "<a href=\"{!URL!}/modules.php?module=admin&amp;what=email_details\">".$value."</a>");
			} else {
				define('__MAIL_BONUS_AP_VALUE', "0");
			}
		} elseif (EXT_IS_ACTIVE("bonus")) {
			define('__MAIL_BONUS_AP_VALUE', sprintf(getMessage('ADMIN_EXT_BONUS_OUTDATED', "0.1.8")));
		} else {
			define('__MAIL_BONUS_AP_VALUE', "<span class=\"admin_note\">{--ADMIN_EXT_BONUS_404--}</span>");
		}
	} else {
		define('__MAIL_BONUS_AP_VALUE', "<span class=\"admin_note\">{--ADMIN_EXT_AUTOPURGE_404--}</span>");
		define('__MAIL_DELETED_VALUE', "<span class=\"admin_note\">{--ADMIN_EXT_AUTOPURGE_404--}</span>");
	}

	//
	// Sent bonus mails
	//
	if (GET_EXT_VERSION("bonus") >= "0.1.8") {
		// Get sent bonus mails (but not notifications)
		$value = GET_TOTAL_DATA("SEND", "bonus", "id", "data_type", true, " AND is_notify='N'");

		if ($value > 0) {
			define('__MAIL_BONUS_SEND_VALUE', "<a href=\"{!URL!}/modules.php?module=admin&amp;what=email_details\">".$value."</a>");
		} else {
			define('__MAIL_BONUS_SEND_VALUE', "0");
		}
	} elseif (EXT_IS_ACTIVE("bonus")) {
		define('__MAIL_BONUS_SEND_VALUE', sprintf(getMessage('ADMIN_EXT_BONUS_OUTDATED', "0.1.8")));
	} else {
		define('__MAIL_BONUS_SEND_VALUE', getMessage('ADMIN_EXT_BONUS_404'));
	}

	if (EXT_IS_ACTIVE("autopurge")) {
		// Start finding them...
		$since = getConfig('ap_inactive_since');
		$EXCLUDE_LIST = "";
		if (getConfig('def_refid') > 0) {
			$EXCLUDE_LIST = " AND d.userid != ".getConfig('def_refid')."";
		} // END - if

		// Check for more extensions
		// @TODO These can be rewritten to filter
		if (EXT_IS_ACTIVE("beg"))                  $EXCLUDE_LIST .= " AND d.userid != ".getConfig('beg_uid')."";
		if (EXT_IS_ACTIVE("bonus"))                $EXCLUDE_LIST .= " AND d.userid != ".getConfig('bonus_uid')."";
		if (EXT_IS_ACTIVE("doubler"))              $EXCLUDE_LIST .= " AND d.userid != ".getConfig('doubler_uid')."";
		if (GET_EXT_VERSION("holiday") >= "0.1.3") $EXCLUDE_LIST .= " AND d.holiday_active='N'";

		// Check for all accounts
		ADD_SQL("SELECT DISTINCT d.userid, d.email, d.last_online
FROM `{!_MYSQL_PREFIX!}_user_data` AS d
WHERE d.`status`='CONFIRMED' AND d.joined < (UNIX_TIMESTAMP() - ".$since.") AND d.last_online < (UNIX_TIMESTAMP() - ".$since.") AND d.ap_notified < (UNIX_TIMESTAMP() - ".$since.")
".$EXCLUDE_LIST."
ORDER BY d.userid");
		$WHATs[]  = "list_autopurge";
		$DESCRs[] = getMessage('ADMIN_TASK_INACTIVE_AUTOPURGE');
		$TITLEs[] = getMessage('ADMIN_TASK_INACTIVE_AUTOPURGE_TITLE');
	}

	if (GET_EXT_VERSION("sql_patches") >= "0.3.4") {
		// Check for accounts without referal
		ADD_SQL("SELECT userid FROM `{!_MYSQL_PREFIX!}_user_data` WHERE refid='0' ORDER BY userid");
		$DESCRs[] = getMessage('ADMIN_TASK_LIST_ACCOUNT_NOREF');
		$TITLEs[] = getMessage('ADMIN_TASK_LIST_ACCOUNT_NOREF_TITLE');
		$WHATs[]  = "list_user&amp;mode=norefs";
	}

	if (EXT_IS_ACTIVE("payout")) {
		// List new payout requests
		ADD_SQL("SELECT userid FROM `{!_MYSQL_PREFIX!}_user_payouts` WHERE `status`='NEW' ORDER BY userid");
		$WHATs[]  = "list_payouts";
		$DESCRs[] = getMessage('ADMIN_TASK_LIST_PAYOUTS_WAITING');
		$TITLEs[] = getMessage('ADMIN_TASK_LIST_PAYOUTS_WAITING_TITLE');
		ADD_SQL("SELECT userid FROM `{!_MYSQL_PREFIX!}_user_payouts` ORDER BY userid");
		$WHATs[]  = "list_payouts";
		$DESCRs[] = getMessage('ADMIN_TASK_LIST_PAYOUTS_ALL');
		$TITLEs[] = getMessage('ADMIN_TASK_LIST_PAYOUTS_ALL_TITLE');
	}

	if (EXT_IS_ACTIVE("wernis")) {
		// List new wernis requests
		ADD_SQL("SELECT userid FROM `{!_MYSQL_PREFIX!}_user_wernis` ORDER BY userid");
		$WHATs[]  = "list_wernis";
		$DESCRs[] = getMessage('ADMIN_TASK_LIST_WERNIS_ALL');
		$TITLEs[] = getMessage('ADMIN_TASK_LIST_WERNIS_ALL_TITLE');
	}

	if (EXT_IS_ACTIVE("primera")) {
		// List new primera requests
		ADD_SQL("SELECT userid FROM `{!_MYSQL_PREFIX!}_user_primera` ORDER BY userid");
		$WHATs[]  = "list_primera";
		$DESCRs[] = getMessage('ADMIN_TASK_LIST_PRIMERA_ALL');
		$TITLEs[] = getMessage('ADMIN_TASK_LIST_PRIMERA_ALL_TITLE');
	}

	if (EXT_IS_ACTIVE("holiday")) {
		// List holiday requests
		ADD_SQL("SELECT userid FROM `{!_MYSQL_PREFIX!}_user_holidays` ORDER BY userid");
		$WHATs[]  = "list_holiday";
		$DESCRs[] = getMessage('ADMIN_TASK_LIST_HOLIDAYS');
		$TITLEs[] = getMessage('ADMIN_TASK_LIST_HOLIDAYS_TITLE');
	}

	if (GET_EXT_VERSION("bonus") >= "0.8.7") {
		// List all notifications
		ADD_SQL("SELECT id FROM `{!_MYSQL_PREFIX!}_bonus` WHERE is_notify='Y' ORDER BY timestamp DESC");
		$WHATs[]  = "list_notifications";
		$DESCRs[] = getMessage('ADMIN_TASK_LIST_NOTIFICATIONS');
		$TITLEs[] = getMessage('ADMIN_TASK_LIST_NOTIFICATIONS_TITLE');
	} // END - if

	if (GET_EXT_VERSION("bonus") >= "0.2.3") {
		// Active rallye
		if (GET_EXT_VERSION("bonus") >= "0.6.9") {
			// Add more bonus points here
			$USE = "(0";
			if (getConfig('bonus_click_yn') == "Y") $USE .= " + turbo_bonus";
			if (getConfig('bonus_login_yn') == "Y") $USE .= " + login_bonus";
			if (getConfig('bonus_order_yn') == "Y") $USE .= " + bonus_order";
			if (getConfig('bonus_stats_yn') == "Y") $USE .= " + bonus_stats";
			if (getConfig('bonus_ref_yn')   == "Y") $USE .= " + bonus_ref";
			$USE .= ")";
		} else {
			// Old version ???
			$USE = "turbo_bonus";
		}

		// Autopurge installed?
		$lastOnline = "";
		if ((EXT_IS_ACTIVE("autopurge")) && (getConfig('autopurge_inactive') == "Y") && (getConfig('ap_inactive_since') > 0)) {
			// Use last online timestamp to keep inactive members away from here
			$lastOnline   = sprintf(" AND last_online >= (UNIX_TIMESTAMP() - %s)", getConfig('ap_inactive_since'));
		}

		ADD_SQL("SELECT ".$USE." AS points
FROM `{!_MYSQL_PREFIX!}_user_data`
WHERE `status`='CONFIRMED' AND ".$USE.">0".$lastOnline."
ORDER BY points DESC, userid");
		$WHATs[]  = "list_bonus";
		$DESCRs[] = getMessage('ADMIN_TASK_LIST_BONUS');
		$TITLEs[] = getMessage('ADMIN_TASK_LIST_BONUS_TITLE');
	}

	if (GET_EXT_VERSION("beg") >= "0.1.2") {
		// Begging rallye

		// Autopurge installed?
		$lastOnline = "";
		if ((EXT_IS_ACTIVE("autopurge")) && (getConfig('autopurge_inactive') == "Y") && (getConfig('ap_inactive_since') > 0)) {
			// Use last online timestamp to keep inactive members away from here
			$lastOnline   = sprintf(" AND last_online >= (UNIX_TIMESTAMP() - %s)", getConfig('ap_inactive_since'));
		}

		ADD_SQL("SELECT userid FROM `{!_MYSQL_PREFIX!}_user_data`
WHERE `status`='CONFIRMED' AND beg_points>0".$lastOnline."
ORDER BY beg_points DESC, userid");
		$WHATs[]  = "list_beg";
		$DESCRs[] = getMessage('ADMIN_TASK_LIST_BEG');
		$TITLEs[] = getMessage('ADMIN_TASK_LIST_BEG_TITLE');
	}

	if (EXT_IS_ACTIVE("doubler")) {
		// List waiting payouts
		ADD_SQL("SELECT id FROM `{!_MYSQL_PREFIX!}_doubler` WHERE completed='N' ORDER BY `id`");
		$WHATs[]  = "list_doubler&amp;mode=waiting&amp;select=all";
		$DESCRs[] = getMessage('ADMIN_TASK_LIST_DOUBLER_WAITING');
		$TITLEs[] = getMessage('ADMIN_TASK_LIST_DOUBLER_WAITING_TITLE');
		ADD_SQL("SELECT id FROM `{!_MYSQL_PREFIX!}_doubler` ORDER BY `id`");
		$WHATs[]  = "list_doubler";
		$DESCRs[] = getMessage('ADMIN_TASK_LIST_DOUBLER_ALL');
		$TITLEs[] = getMessage('ADMIN_TASK_LIST_DOUBLER_ALL_TITLE');
	}

	//
	// All referal banner
	//
	ADD_SQL("SELECT id FROM `{!_MYSQL_PREFIX!}_refbanner` ORDER BY `id`");
	$WHATs[] = "refbanner";
	$DESCRs[] = getMessage('ADMIN_TASK_LIST_REFBANNER_ALL');
	$TITLEs[] = getMessage('ADMIN_TASK_LIST_REFBANNER_ALL_TITLE');

	//
	// All activated referal banner
	//
	ADD_SQL("SELECT id FROM `{!_MYSQL_PREFIX!}_refbanner` WHERE `visible`='Y' ORDER BY `id`");
	$WHATs[] = "refbanner";
	$DESCRs[] = getMessage('ADMIN_TASK_LIST_REFBANNER_ACTIVE');
	$TITLEs[] = getMessage('ADMIN_TASK_LIST_REFBANNER_ACTIVE_TITLE');

	//
	// All extensions
	//
	ADD_SQL("SELECT id FROM `{!_MYSQL_PREFIX!}_extensions` ORDER BY `id`");
	$WHATs[] = "extensions";
	$DESCRs[] = getMessage('ADMIN_TASK_LIST_EXTENSIONS_ALL');
	$TITLEs[] = getMessage('ADMIN_TASK_LIST_EXTENSIONS_ALL_TITLE');

	//
	// All activated extensions
	//
	ADD_SQL("SELECT id FROM `{!_MYSQL_PREFIX!}_extensions` WHERE ext_active='Y' ORDER BY `id`");
	$WHATs[]  = "extensions&amp;active=Y";
	$DESCRs[] = getMessage('ADMIN_TASK_LIST_EXTENSIONS_ACTIVE');
	$TITLEs[] = getMessage('ADMIN_TASK_LIST_EXTENSIONS_ACTIVE_TITLE');

	if (EXT_IS_ACTIVE("engine")) {
		// List all export accounts
		ADD_SQL("SELECT id FROM `{!_MYSQL_PREFIX!}_engine_accounts` ORDER BY `id`");
		$WHATs[]  = "list_engine";
		$DESCRs[] = getMessage('ADMIN_TASK_LIST_ENGINE');
		$TITLEs[] = getMessage('ADMIN_TASK_LIST_ENGINE_TITLE');

		// List all pending accounts
		ADD_SQL("SELECT id FROM `{!_MYSQL_PREFIX!}_engine_accounts` WHERE `status`='UNCONFIRMED' ORDER BY `id`");
		$WHATs[]  = "unlock_engine";
		$DESCRs[] = getMessage('ADMIN_TASK_UNLOCK_ENGINE');
		$TITLEs[] = getMessage('ADMIN_TASK_UNLOCK_ENGINE_TITLE');

		// List all safes
		ADD_SQL("SELECT id FROM `{!_MYSQL_PREFIX!}_engine_safe` ORDER BY `id`");
		$WHATs[]  = "list_engine&amp;mode=safe";
		$DESCRs[] = getMessage('ADMIN_TASK_LIST_ENGINE_SAFES');
		$TITLEs[] = getMessage('ADMIN_TASK_LIST_ENGINE_SAFES_TITLE');

		// List all export URLs
		ADD_SQL("SELECT id FROM `{!_MYSQL_PREFIX!}_engine_urls` ORDER BY `id`");
		$WHATs[]  = "engine_urls";
		$DESCRs[] = getMessage('ADMIN_TASK_LIST_ENGINE_URLS');
		$TITLEs[] = getMessage('ADMIN_TASK_LIST_ENGINE_URLS_TITLE');
	}

	if (EXT_IS_ACTIVE("sponsor")) {
		// List all sponsors
		ADD_SQL("SELECT id FROM `{!_MYSQL_PREFIX!}_sponsor_data` ORDER BY `id`");
		$WHATs[]  = "list_sponsor";
		$DESCRs[] = getMessage('ADMIN_TASK_LIST_SPONSOR');
		$TITLEs[] = getMessage('ADMIN_TASK_LIST_SPONSOR_TITLE');

		// List confirmed sponsor accounts
		ADD_SQL("SELECT id FROM `{!_MYSQL_PREFIX!}_sponsor_data` WHERE `status`='CONFIRMED' ORDER BY `id`");
		$WHATs[]  = "list_sponsor";
		$DESCRs[] = getMessage('ADMIN_TASK_LIST_SPONSOR_CONFIRMED');
		$TITLEs[] = getMessage('ADMIN_TASK_LIST_SPONSOR_CONFIRMED_TITLE');

		// List unconfirmed sponsor accounts
		ADD_SQL("SELECT id FROM `{!_MYSQL_PREFIX!}_sponsor_data` WHERE `status`='UNCONFIRMED' ORDER BY `id`");
		$WHATs[]  = "list_sponsor";
		$DESCRs[] = getMessage('ADMIN_TASK_LIST_SPONSOR_UNCONFIRMED');
		$TITLEs[] = getMessage('ADMIN_TASK_LIST_SPONSOR_UNCONFIRMED_TITLE');

		// List locked sponsor accounts
		ADD_SQL("SELECT id FROM `{!_MYSQL_PREFIX!}_sponsor_data` WHERE `status`='LOCKED' ORDER BY `id`");
		$WHATs[]  = "list_sponsor";
		$DESCRs[] = getMessage('ADMIN_TASK_LIST_SPONSOR_LOCKED');
		$TITLEs[] = getMessage('ADMIN_TASK_LIST_SPONSOR_LOCKED_TITLE');

		// List waiting sponsor accounts to be approved
		ADD_SQL("SELECT id FROM `{!_MYSQL_PREFIX!}_sponsor_data` WHERE `status`='PENDING' ORDER BY `id`");
		$WHATs[]  = "unlock_sponsor";
		$DESCRs[] = getMessage('ADMIN_TASK_LIST_SPONSOR_PENDING');
		$TITLEs[] = getMessage('ADMIN_TASK_LIST_SPONSOR_PENDING_TITLE');

		// Waiting payments
		ADD_SQL("SELECT id FROM `{!_MYSQL_PREFIX!}_sponsor_orders` WHERE pay_`status`='PENDING' ORDER BY `id`");
		$WHATs[]  = "list_sponsor_pays";
		$DESCRs[] = getMessage('ADMIN_TASK_LIST_SPONSOR_ORDERS');
		$TITLEs[] = getMessage('ADMIN_TASK_LIST_SPONSOR_ORDERS_TITLE');
	}

	if (EXT_IS_ACTIVE("country")) {
		// List country codes
		ADD_SQL("SELECT id FROM `{!_MYSQL_PREFIX!}_countries` ORDER BY `id`");
		$WHATs[]  = "list_country";
		$DESCRs[] = getMessage('ADMIN_TASK_LIST_COUNTRY');
		$TITLEs[] = getMessage('ADMIN_TASK_LIST_COUNTRY_TITLE');
	}

	if (EXT_IS_ACTIVE("theme")) {
		// List all themes
		ADD_SQL("SELECT id FROM `{!_MYSQL_PREFIX!}_themes` ORDER BY `id`");
		$WHATs[]  = "theme_edit";
		$DESCRs[] = getMessage('ADMIN_TASK_LIST_THEME_ALL');
		$TITLEs[] = getMessage('ADMIN_TASK_LIST_THEME_ALL_TITLE');

		// List active themes
		ADD_SQL("SELECT id FROM `{!_MYSQL_PREFIX!}_themes` WHERE theme_active='Y' ORDER BY `id`");
		$WHATs[]  = "theme_edit";
		$DESCRs[] = getMessage('ADMIN_TASK_LIST_THEME_ACTIVE');
		$TITLEs[] = getMessage('ADMIN_TASK_LIST_THEME_ACTIVE_TITLE');
	}

	if (EXT_IS_ACTIVE("admins")) {
		// List all administrator logins
		ADD_SQL("SELECT id FROM `{!_MYSQL_PREFIX!}_admins` ORDER BY `id`");
		$WHATs[]  = "admins_edit";
		$DESCRs[] = getMessage('ADMIN_TASK_LIST_ADMINS_ALL');
		$TITLEs[] = getMessage('ADMIN_TASK_LIST_ADMINS_ALL_TITLE');
	}

	if (EXT_IS_ACTIVE("surfbar")) {
		// List all URLs in surfbar
		ADD_SQL("SELECT id FROM `{!_MYSQL_PREFIX!}_surfbar_urls` ORDER BY `id`");
		$WHATs[]  = "list_surfbar_urls";
		$DESCRs[] = getMessage('ADMIN_TASK_LIST_SURFBAR_URLS_ALL');
		$TITLEs[] = getMessage('ADMIN_TASK_LIST_SURFBAR_URLS_ALL_TITLE');

		// List all pending URLs in surfbar
		ADD_SQL("SELECT id FROM `{!_MYSQL_PREFIX!}_surfbar_urls` WHERE `status`='PENDING' ORDER BY `id`");
		$WHATs[]  = "unlock_surfbar_urls";
		$DESCRs[] = getMessage('ADMIN_TASK_LIST_SURFBAR_URLS_PENDING');
		$TITLEs[] = getMessage('ADMIN_TASK_LIST_SURFBAR_URLS_PENDING_TITLE');
	}

	// Generate extra overview rows
	$EXTRAS .= TASK_CREATE_EXTRA_ROWS($WHATs, $DESCRs, $TITLEs);

	// If empty just keep a forced-space left for CSS issues
	if (empty($EXTRAS)) $EXTRAS = "&nbsp;";

	// Add compiled string to constant for final template
	define('__OVERVIEW_EXTRA_TABLE', $EXTRAS);

	// Simply load the template... :-)
	LOAD_TEMPLATE("admin_overview_task");
}

//
function TASK_CREATE_EXTRA_ROWS ($WHATs, $DESCRs, $TITLEs) {
	// Init variables
	$OUT = ""; $SW = 2;

	// Sadly this cannot be rewritten to a filter... :(
	foreach (GET_SQLS() as $key => $sql) {
		// Run SQL command, get line numbers and free memory
		$result = SQL_QUERY($sql, __FUNCTION__, __LINE__);

		// Get rows
		$value = SQL_NUMROWS($result);

		// Free result
		SQL_FREERESULT($result);

		// Prepare array for output
		$content = array(
			'row_descr' => $DESCRs[$key],
			'row_sw'    => $SW,
			'bottom'    => "",
		);

		// Rewrite CSS class if not last entry is reached
		if ($key < (COUNT_SQLS() - 1)) $content['bottom'] = "bottom2";

		if (($value > 0) && (!empty($WHATs[$key]))) {
			if (empty($TITLEs[$key])) $TITLEs[$key] = getMessage('ADMIN_TASK_UNKNOWN_LIST_TITLE');
			$content['row_link'] = "<a href=\"{!URL!}/modules.php?module=admin&amp;what=".$WHATs[$key]."\" title=\"".$TITLEs[$key]."\">".$value."</a>";
		} else {
			$content['row_link'] = 0;
		}

		// And insert the final string into extras template
		$OUT .= LOAD_TEMPLATE("admin_overview_task_rows", true, $content);

		// Switch color
		$SW = 3 - $SW;
	} // END - if

	// Return output in the template
	return LOAD_TEMPLATE("admin_overview_task_extras", true, $OUT);
}

//
?>
