<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 09/09/2008 *
 * ================                             Last change: 09/09/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_primera.php                          *
 * -------------------------------------------------------------------- *
 * Short description : Configure primera sub-system                     *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Auszahlungensarten editieren                     *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Add description as navigation point
ADD_DESCR("admin", __FILE__);

if (IS_FORM_SENT()) {
	// First merge temporarily the new API data into the current config
	mergeConfig(REQUEST_POST_ARRAY());

	// Is the password set?
	if (REQUEST_ISSET_POST(('pass'))) {
		// Then hash and remove it
		REQUEST_SET_POST('primera_api_md5', md5(REQUEST_POST('pass')));
		REQUEST_UNSET_POST('pass');
	} // END - if

	// Let's test the API first (hold your horses here, cowboy! Thank you. :) )
	if (PRIMERA_TEST_API()) {
		// Save settings
		ADMIN_SAVE_SETTINGS_POST();
	} else {
		// Failed to test the API!
		LOAD_TEMPLATE("admin_settings_saved", false, GET_PRIMERA_ERROR_MESSAGE());
	}
}  else {
	// Prepare data for template output
	$content = array(
		'min_payout'		=> getConfig(('primera_min_payout')),
		'min_withdraw'		=> getConfig(('primera_min_withdraw')),
		'api_name'		=> getConfig('primera_api_name'),
		'api_md5'			=> getConfig('primera_api_md5'),
		'refid'			=> getConfig('primera_refid')
	);

	// Load template
	LOAD_TEMPLATE("admin_config_primera", false, $content);
}

//
?>
