<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 09/23/2003 *
 * ===============                              Last change: 03/27/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : index.php                                        *
 * -------------------------------------------------------------------- *
 * Short description : Entrance page                                    *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Eingangsseite                                    *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
} elseif (!EXT_IS_ACTIVE("sql_patches")) {
	// The extension "sql_patches" *MUST* be activated or you have lot's of problems!
	LOAD_URL("admin.php");
}

// Load adverstising template
define('__GUEST_ADVERT', LOAD_TEMPLATE("guest_advert", true));

// Generate a tableset for the menu title and content
LOAD_TEMPLATE("guest_header");

// Add message here
if (REQUEST_ISSET_GET(('msg'))) {
	// Default extension is "unknown"
	$ext = "unknown";

	// Is extension given?
	if (REQUEST_ISSET_GET(('ext'))) $ext = REQUEST_GET(('ext'));

	// Which message shall we output?
	$msg = convertCodeToMessage(REQUEST_GET('msg'));

	// Load message template
	LOAD_TEMPLATE("message", false, $msg);
} // END - if

// Some of you needs this to be extracted into a template... ???
LOAD_TEMPLATE("guest_menu_td");

// When no what value is provided take the "home" value
if (empty($GLOBALS['what'])) $GLOBALS['what'] = getConfig('index_home');

// Adding the main content module here
if (empty($GLOBALS['action'])) {
	// Get action value from what value
	$GLOBALS['action'] = GET_ACTION("guest", $GLOBALS['what']);
} // END - if

// Add the guest's menu here...
if ((getConfig('guest_menu') == "Y") || (!EXT_IS_ACTIVE("sql_patches", true))) {
	// Show only when guest menu is active
	ADD_MENU("guest", $GLOBALS['action'], $GLOBALS['what']);
} // END - if

// TDs between menu and content
LOAD_TEMPLATE("guest_menu_content");

// Disable block-mode by default
$GLOBALS['block_mode'] = false;

// Construct FQFN
$INC = sprintf("inc/modules/guest/action-%s.php", $GLOBALS['action']);

// Is the file there?
if ((INCLUDE_READABLE($INC)) && (VALIDATE_MENU_ACTION("guest", $GLOBALS['action'], $GLOBALS['what']))) {
	// Requested module is available so we load it
	LOAD_INC_ONCE($INC);
} else {
	// Invalid module specified or not found...
	LOAD_URL("modules.php?module=index");
}

if ((getConfig('guest_menu') == "Y") || (!EXT_IS_ACTIVE("sql_patches", true))) {
	// Right side of content (hint: a good place for 120x600 skyscraper banner!)
	LOAD_TEMPLATE("guest_content_footer");

	// Some advertising stuff?
	LOAD_TEMPLATE("guest_advert2");

	OUTPUT_HTML("  </td>
</tr>");

	// Goto TOP template
	LOAD_TEMPLATE("guest_goto_top");
} // END - if

// Footer template (Thanx to Mr. Glaus!)
LOAD_TEMPLATE("guest_footer");

//
?>
