<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 06/29/2004 *
 * ================                             Last change: 08/22/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-rallyes.php                                 *
 * -------------------------------------------------------------------- *
 * Short description : Ref rallyes                                      *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Ref-Rallyes                                      *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
} elseif (!IS_MEMBER()) {
	LOAD_URL("modules.php?module=index");
} elseif ((!EXT_IS_ACTIVE("rallye")) && (!IS_ADMIN())) {
	addFatalMessage(__FILE__, __LINE__, getMessage('EXTENSION_PROBLEM_EXT_INACTIVE'), "rallye");
	return;
}

// Add description as navigation point
ADD_DESCR("member", __FILE__);

OUTPUT_HTML("<div align=\"center\">");

// Check for possible running rallyes
$ADMIN = " AND d.is_active='Y'";
if (IS_ADMIN()) $ADMIN = "";
$result = SQL_QUERY("SELECT DISTINCT d.id, d.admin_id, a.login, d.title, d.descr, d.template, d.start_time, d.end_time, d.min_users, d.min_prices
 FROM `{!_MYSQL_PREFIX!}_rallye_data` AS d, `{!_MYSQL_PREFIX!}_admins` AS a
 WHERE d.admin_id=a.id".$ADMIN." AND d.notified='Y'
 ORDER BY d.end_time LIMIT 1", __FILE__, __LINE__);

if (SQL_NUMROWS($result) == 1) {
	// Found some (normally one...
	list($id, $aid, $login, $title, $descr, $templ, $start, $end, $min_users, $min_prices) = SQL_FETCHROW($result);
	SQL_FREERESULT($result);

	$expired = false;
	if ($end < time()) {
		// Rallye is expired
		define('__RALLYE_EXTRAS', getMessage('RALLYE_HAS_EXPIRED'));
		$expired = true;
	} elseif (time() >= ($end - getConfig('one_day'))) {
		// Rallye will expire in less one day!
		define('__RALLYE_EXTRAS', getMessage('RALLYE_EXPIRE_ONE_DAY'));
	} else {
		define('__RALLYE_EXTRAS', "<a href=\"{!URL!}/modules.php?module=login&amp;what=reflinks\">{--RALLYE_GET_REFLINK--}</a>");
	}

	// Set admin line (currently set to impressum, later to contact form)
	define('__RALLYE_ADMIN', "<a href=\"{!URL!}/modules.php?module=index&amp;what=impressum&amp;admin=".$aid."\">".$login."</a>");

	// Set title
	define('__RALLYE_TITLE', COMPILE_CODE($title));

	// Handle description...
	if ((empty($descr)) && (!empty($templ))) {
		// Use description from template
		define('__RALLYE_DESCR', LOAD_TEMPLATE("rallye_".$templ, true));
	} else {
		// Use description from database
		define('__RALLYE_DESCR', COMPILE_CODE($descr));
	}

	// Determine min_users/prices
	define('__RALLYE_MAX_USERS' ,  RALLYE_DETERMINE_MIN_USERS($min_users));
	define('__RALLYE_MAX_PRICES',  RALLYE_DETERMINE_MIN_PRICES($min_prices));

	// Set start and end time
	define('__RALLYE_START', MAKE_DATETIME($start, "1"));
	define('__RALLYE_END'  , MAKE_DATETIME($end  , "1"));

	if ($expired === true) {
		define('__RALLYE_PRICES', RALLYE_LIST_WINNERS($id));
		define('__RALLYE_TOP_USERS', "<div align=\"center\" class=\"big\">{!__RALLYE_EXTRAS!}</div>");
		define('__RALLYE_CAN_WIN_THIS', getMessage('RALLYE_OUR_WINNERS_ARE'));
	} else {
		define('__RALLYE_PRICES', RALLYE_ADD_PRICES($id, "html"));
		define('__RALLYE_TOP_USERS', RALLYE_ADD_TOPUSERS($id, $GLOBALS['userid']));
		define('__RALLYE_CAN_WIN_THIS', getMessage('RALLYE_YOU_CAN_WIN'));
	}

	// And load final template
	LOAD_TEMPLATE("guest_rallye_show");
} else {
	// No rallye found so far
	LOAD_TEMPLATE("guest_no_rallyes");
}

//
OUTPUT_HTML("</div>");

//
?>
