<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 09/17/2008 *
 * ================                             Last change: 09/17/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-surfbar_list.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Surfbar URL statistics                           *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Surfbar-Statistiken                              *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
} elseif (!IS_MEMBER()) {
	LOAD_URL("modules.php?module=index");
} elseif ((!EXT_IS_ACTIVE("surfbar")) && (!IS_ADMIN())) {
	addFatalMessage(__FILE__, __LINE__, getMessage('EXTENSION_PROBLEM_EXT_INACTIVE'), "surfbar");
	return;
}

// Add description as navigation point
ADD_DESCR("member", __FILE__);

// Load user URLs
$URLs = SURFBAR_GET_USER_URLS();

// Are there entries or form is submitted?
if ((IS_FORM_SENT()) && (REQUEST_ISSET_POST(('action'))) && (REQUEST_ISSET_POST(('id')))) {
	// Process the form
	if (SURFBAR_MEMBER_DO_FORM(REQUEST_POST_ARRAY(), $URLs)) {
		// Action performed but shall we display it?
		if (((REQUEST_POST('action') != "edit") && (REQUEST_POST('action') != "delete")) || (REQUEST_ISSET_POST(('execute')))) {
			// Display "action done" message if action is wether 'edit' nor 'delete' or has been executed
			LOAD_TEMPLATE("admin_settings_saved", false, getMessage('MEMBER_SURFBAR_ACTION_DONE'));
		} // END - if
	} else {
		// Something went wrong
		LOAD_TEMPLATE("admin_settings_saved", false, getMessage('MEMBER_SURFBAR_ACTION_FAILED'));
	}
} elseif (count($URLs) > 0) {
	// List all URLs
	$OUT = ""; $SW = 2;
	foreach ($URLs as $id => $content) {
		// "Translate"/insert data
		$content['sw'] = $SW;
		$content['url'] = DEREFERER($content['url']);
		if ($content['views_total'] > 0) {
			// Include link to stats
			$content['views_total'] = "[<a href=\"{!URL!}/modules.php?module=login&amp;what=surfbar_list\">".TRANSLATE_COMMA($content['views_total'])."</a>]";
		} // END - if
		$content['registered']  = MAKE_DATETIME($content['registered'], "2");
		$content['last_locked'] = MAKE_DATETIME($content['last_locked'], "2");
		$content['actions']     = SURFBAR_MEMBER_ACTIONS($content['id'], $content['status']);
		$content['status']      = SURFBAR_TRANSLATE_STATUS($content['status']);
		if (empty($content['lock_reason'])) {
			// Fixes some HTML problems with empty cells
			$content['lock_reason'] = "---";
		} // END - if

		// Load row template
		$OUT .= LOAD_TEMPLATE("member_surfbar_list_row", true, $content);

		// Switch color
		$SW = 3 - $SW;
	} // END - if

	// Load main template
	LOAD_TEMPLATE("member_surfbar_list", false, $OUT);
} else {
	// No URLs booked so far
	LOAD_TEMPLATE("admin_settings_saved", false, getMessage('MEMBER_SURFBAR_NO_URLS_FOUND'));
}

//
?>
