<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 11/14/2003 *
 * ===============                              Last change: 11/25/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : mailid.php                                       *
 * -------------------------------------------------------------------- *
 * Short description : Confirmation file for emails                     *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Bestaetigung von Mails                           *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Load security stuff here (Oh, I hope this is not unsecure? Am I paranoia??? ;-) )
require("inc/libs/security_functions.php");

// Init "action" and "what"
$GLOBALS['what'] = "";
$GLOBALS['action'] = "";

// Tell everyone we are in this module
$GLOBALS['module'] = "mailid";
$GLOBALS['output_mode'] = -1;

// Load the required file(s)
require("inc/config.php");

if (isInstalled()) {
	// Is the extension active?
	REDIRECT_ON_UNINSTALLED_EXTENSION("mailid");

	// Init
	$url_uid = 0; $url_bid = 0; $url_mid = 0;

	// Secure all data
	if (REQUEST_ISSET_GET(('uid')))     $url_uid = bigintval(REQUEST_GET('uid'));
	if (REQUEST_ISSET_GET(('mailid')))  $url_mid = bigintval(REQUEST_GET('mailid'));
	if (REQUEST_ISSET_GET(('bonusid'))) $url_bid = bigintval(REQUEST_GET('bonusid'));

	// 01        1        12            3    32           21    1                   22     10
	if (($url_uid) > 0 && (($url_mid > 0) || ($url_bid > 0)) && (getTotalFatalErrors() == 0)) {
		// Maybe he wants to confirm an email?
		if ($url_mid > 0) {
			// Normal-Mails
			$result = SQL_QUERY_ESC("SELECT link_type FROM `{!_MYSQL_PREFIX!}_user_links` WHERE stats_id=%s AND userid=%s LIMIT 1",
				array($url_mid, $url_uid), __FILE__, __LINE__);
			$type = "mailid"; $DATA = $url_mid;
		} elseif ($url_bid > 0) {
			// Bonus-Mail
			$result = SQL_QUERY_ESC("SELECT link_type FROM `{!_MYSQL_PREFIX!}_user_links` WHERE bonus_id=%s AND userid=%s LIMIT 1",
				array($url_bid, $url_uid), __FILE__, __LINE__);
			$type = "bonusid"; $DATA = $url_bid;
		} else {
			// Problem: No ID entered
			LOAD_URL("index.php");
		}

		if (SQL_NUMROWS($result) == 1) {
			// Load the entry
			list($ltype) = SQL_FETCHROW($result);

			// Clean result
			SQL_FREERESULT($result);

			switch ($ltype)
			{
			case "NORMAL":
				// Is the stats ID valid?
				$result = SQL_QUERY_ESC("SELECT pool_id, url, subject FROM `{!_MYSQL_PREFIX!}_user_stats` WHERE id=%s LIMIT 1",
					array($url_mid), __FILE__, __LINE__);
				break;

			case "BONUS":
				// Is the bonus extension active?
				REDIRECT_ON_UNINSTALLED_EXTENSION("bonus");

				// Bonus-Mails
				$result = SQL_QUERY_ESC("SELECT id, url, subject FROM `{!_MYSQL_PREFIX!}_bonus` WHERE id=%s LIMIT 1",
					array($url_bid), __FILE__, __LINE__);
				break;
			}

			if (SQL_NUMROWS($result) == 1) {
				// Load data
				list($pool, $URL, $EXTRA_TITLE) = SQL_FETCHROW($result);

				// Free result
				SQL_FREERESULT($result);

				// Compile extra title
				$EXTRA_TITLE = COMPILE_CODE($EXTRA_TITLE);

				// Is the user's ID unlocked?
				$result = SQL_QUERY_ESC("SELECT status, gender, surname, family FROM `{!_MYSQL_PREFIX!}_user_data` WHERE userid=%s LIMIT 1",
					array($url_uid), __FILE__, __LINE__);
				if (SQL_NUMROWS($result) == 1) {
					list($status, $gender, $sname, $fname) = SQL_FETCHROW($result);
					SQL_FREERESULT($result);
					if ($status == "CONFIRMED") {
						// User has confirmed his account so we can procede...
						switch ($ltype)
						{
						case "NORMAL":
							$result = SQL_QUERY_ESC("SELECT payment_id FROM `{!_MYSQL_PREFIX!}_user_stats` WHERE pool_id=%s LIMIT 1",
								array(bigintval($pool)), __FILE__, __LINE__);
							if (SQL_NUMROWS($result) == 1) {
								list($pay) = SQL_FETCHROW($result);
								$time      = GET_PAY_POINTS($pay, "time");
								$payment   = GET_PAY_POINTS($pay, "payment");
								$VALID     = true;
							}

							// Free memory
							SQL_FREERESULT($result);
							break;

						case "BONUS":
							$result = SQL_QUERY_ESC("SELECT points, time FROM `{!_MYSQL_PREFIX!}_bonus` WHERE id=%s LIMIT 1",
								array($url_bid), __FILE__, __LINE__);
							if (SQL_NUMROWS($result) == 1) {
								list($points, $time) = SQL_FETCHROW($result);
								$payment = "0.00000";
								$VALID = true;
							}

							// Free memory
							SQL_FREERESULT($result);
							break;
						}

						// Add header
						LOAD_INC_ONCE("inc/header.php");

						// Was that mail a valid one?
						if ($VALID) {
							// If time is zero seconds we have a sponsor mail. 1 Second shall be set to avoid problems
							if (($time == "0") && ($payment > 0)) { $URL = constant('URL'); $time = "1"; }
							if (($time > 0) && (($payment > 0) || ($points > 0))) {
								// He can confirm this mail!
								// Export data into constants for the template
								define('_UID_VALUE' , $url_uid);
								define('_TYPE_VALUE', $type);
								define('_DATA_VALUE', $DATA);
								define('_URL_VALUE' , DEREFERER($URL));

								// Load template
								LOAD_TEMPLATE("mailid_frames");
							} else {
								$msg = constant('CODE_DATA_INVALID');
							}
						} else {
							$msg = constant('CODE_POSSIBLE_INVALID');
						}
					} else {
						$msg = constant('CODE_ACCOUNT_LOCKED');
					}
				} else {
					SQL_FREERESULT($result);
					$msg = constant('CODE_USER_404');
				}
			} else {
				SQL_FREERESULT($result);
				$msg = constant('CODE_STATS_404');
			}
		} else {
			SQL_FREERESULT($result);
			$msg = constant('CODE_ALREADY_CONFIRMED');
		}
	} else {
		// Nothing entered
		$msg = constant('CODE_ERROR_MAILID');
	}

	// Error code is set?
	if (!empty($msg)) {
		switch (getConfig('mailid_error_redirect')) {
			case "INDEX": // Redirect to index page
				LOAD_URL("modules.php?module=index&amp;msg=".$msg."&amp;ext=mailid");
				break;

			case "REJECT": // Redirect to rejection page
				LOAD_CONFIGURED_URL('reject_url');
				break;

			default:
				DEBUG_LOG(__FILE__, __LINE__, sprintf("Unknown status %s detected in mailid_error_redirect.", getConfig('mailid_error_redirect')));
				LOAD_URL("modules.php?module=index&amp;msg=".constant('CODE_UNKNOWN_STATUS')."&amp;ext=mailid");
				break;
		}
	} else {
		// Include footer
		LOAD_INC_ONCE("inc/footer.php");
	}
} else {
	// You have to install first!
	LOAD_URL("install.php");
}

//
?>
